defmodule Euler.Two do
  @moduledoc """
  Each new term in the Fibonacci sequence is generated by adding the previous two terms. By starting with 1 and 2, the first 10 terms will be:

  1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...

  By considering the terms in the Fibonacci sequence whose values do not exceed four million, find the sum of the even-valued terms.
  """

  @doc """
  Finds sum of even fibonacci numbers up to limit

  ## Examples
    iex> Euler.Two.solve(90)
    44
  """
  def solve(limit) do
    solve({ 2, 1 }, limit, 2)
  end

  defp solve({n1, n2}, limit, sum) when n1 + n2 > limit do
    sum
  end

  defp solve({n1, n2}, limit, sum) when rem(n1 + n2, 2) == 0 do
    solve({n1 + n2, n1}, limit, sum + n1 + n2)
  end

  defp solve({n1, n2}, limit, sum) do
    solve({n1 + n2, n1}, limit, sum)
  end
end
